'use strict';var vue=require('vue');function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}

function _iterableToArrayLimit(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;

  var _s, _e;

  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}var lerp = function lerp(current, goal, p) {
  return (1 - p) * current + p * goal;
};
var flipVal = function flipVal(val, min, max) {
  return Math.abs(val * (Math.sign(val) || 1) - max) + min;
};
function valToP(value, min, max) {
  if (min > max) {
    var _ref = [max, min];
    min = _ref[0];
    max = _ref[1];
    value = flipVal(value, min, max);
  }

  return (value - min) / (max - min);
}/*!
  * vue-global-events v2.0.1
  * (c) 2020 Damian Dulisz, Eduardo San Martin Morote
  * @license MIT
  */

let _isIE;
function isIE() {
    return _isIE == null
        ? (_isIE = /msie|trident/.test(window.navigator.userAgent.toLowerCase()))
        : _isIE;
}

const EVENT_NAME_RE = /^on(\w+?)((?:Once|Capture|Passive)*)$/;
const MODIFIERS_SEPARATOR_RE = /[OCP]/g;
function extractEventOptions(modifiersRaw) {
    if (!modifiersRaw)
        return;
    // IE only supports capture option and it has to be a boolean
    // https://github.com/shentao/vue-global-events/issues/14
    if (isIE()) {
        return modifiersRaw.includes('Capture');
    }
    const modifiers = modifiersRaw
        .replace(MODIFIERS_SEPARATOR_RE, ',$&')
        .toLowerCase()
        // remove the initial comma
        .slice(1)
        .split(',');
    return modifiers.reduce((options, modifier) => {
        options[modifier] = true;
        return options;
    }, {});
}
const GlobalEventsImpl = vue.defineComponent({
    name: 'GlobalEvents',
    props: {
        target: {
            type: String,
            default: 'document',
        },
        filter: {
            type: Function,
            default: () => () => true,
        },
    },
    setup(props, { attrs }) {
        let activeListeners = Object.create(null);
        const isActive = vue.ref(true);
        vue.onActivated(() => {
            isActive.value = true;
        });
        vue.onDeactivated(() => {
            isActive.value = false;
        });
        vue.onMounted(() => {
            Object.keys(attrs)
                .filter((name) => name.startsWith('on'))
                .forEach((eventNameWithModifiers) => {
                const listener = attrs[eventNameWithModifiers];
                const listeners = Array.isArray(listener) ? listener : [listener];
                const match = eventNameWithModifiers.match(EVENT_NAME_RE);
                if (!match) {
                    return;
                }
                let [, eventName, modifiersRaw] = match;
                eventName = eventName.toLowerCase();
                const handlers = listeners.map((listener) => (event) => {
                    isActive.value &&
                        props.filter(event, listener, eventName) &&
                        listener(event);
                });
                const options = extractEventOptions(modifiersRaw);
                handlers.forEach((handler) => {
                    window[props.target].addEventListener(eventName, handler, options);
                });
                activeListeners[eventNameWithModifiers] = [
                    handlers,
                    eventName,
                    options,
                ];
            });
        });
        vue.onBeforeUnmount(() => {
            for (const eventNameWithModifiers in activeListeners) {
                const [handlers, eventName, options] = activeListeners[eventNameWithModifiers];
                handlers.forEach((handler) => {
                    window[props.target].removeEventListener(eventName, handler, options);
                });
            }
            activeListeners = {};
        });
        return () => null;
    },
});
// export the public type for h/tsx inference
// also to avoid inline import() in generated d.ts files
/**
 * Component of vue-lib.
 */
const GlobalEvents = GlobalEventsImpl;var setTransform = function setTransform(element, x, y) {
  if (element.style) element.style.transform = "translateX(".concat(x, "px) translateY(").concat(y, "px)");
};

var followMouse = function followMouse(element, p, target) {
  var _element$getBoundingC = element.getBoundingClientRect(),
      left = _element$getBoundingC.left,
      top = _element$getBoundingC.top; // Apply LERP


  var x = lerp(left, target.x, p);
  var y = lerp(top, target.y, p); // Set Position using Transforms

  setTransform(element, x, y);
};

var script = vue.defineComponent({
  name: 'GooeyCursor',
  components: {
    GlobalEvents: GlobalEvents
  },
  props: {
    size: {
      type: Number,
      default: 32
    },
    length: {
      type: Number,
      default: 8
    },
    color: {
      type: String,
      default: undefined
    },
    hover: {
      type: String,
      default: 'a, button'
    }
  },
  setup: function setup(props) {
    var animation;
    var target = {
      x: 0,
      y: 0
    };
    var cursors = [];
    var cursorEl = vue.ref();
    var mouseOut = vue.ref(true),
        clicking = vue.ref(false),
        hoverActive = vue.ref(false);

    function draw() {
      cursors.forEach(function (_ref) {
        var el = _ref.el,
            p = _ref.p;
        return followMouse(el, p, target);
      });
      animation = requestAnimationFrame(draw);
    }

    function handleMouseMove(e) {
      var el = e.target;
      hoverActive.value = !!(el !== null && el !== void 0 && el.matches(props.hover));
      mouseOut.value = false;
      target.x = e.clientX - props.size / 2;
      target.y = e.clientY - props.size / 2;
    }

    vue.onMounted(function () {
      var _cursorEl$value;

      // Set variables: (cursors element list)
      // And set "--scale" css variable
      var children = (_cursorEl$value = cursorEl.value) === null || _cursorEl$value === void 0 ? void 0 : _cursorEl$value.children;

      if (children) {

        _toConsumableArray(children).forEach(function (el, i) {
          var p = valToP(i + 1, 0, props.length);
          cursors.push({
            el: el,
            p: p
          });
          el.style.setProperty('--scale', String(p));
        });
      }

      animation = requestAnimationFrame(draw);
    });
    vue.onUnmounted(function () {
      cancelAnimationFrame(animation);
    });
    return {
      cursorEl: cursorEl,
      handleMouseMove: handleMouseMove,
      mouseOut: mouseOut,
      clicking: clicking,
      hoverActive: hoverActive
    };
  }
});var _withId = /*#__PURE__*/vue.withScopeId("data-v-3798d71c");

vue.pushScopeId("data-v-3798d71c");

var _hoisted_1 = /*#__PURE__*/vue.createVNode("svg", {
  class: "svg-effect"
}, [/*#__PURE__*/vue.createVNode("defs", null, [/*#__PURE__*/vue.createVNode("filter", {
  id: "gooey-cursor-svg-effect"
}, [/*#__PURE__*/vue.createVNode("feGaussianBlur", {
  in: "SourceGraphic",
  stdDeviation: "6",
  result: "blur"
}), /*#__PURE__*/vue.createVNode("feColorMatrix", {
  in: "blur",
  mode: "matrix",
  values: "1 0 0 0 0  0 1 0 0 0  0 0 1 0 0  0 0 0 35 -15",
  result: "gooey-cursor-svg-effect"
}), /*#__PURE__*/vue.createVNode("feComposite", {
  in: "SourceGraphic",
  in2: "gooey-cursor-svg-effect",
  operator: "atop"
})])])], -1);

var _hoisted_2 = /*#__PURE__*/vue.createVNode("svg", {
  viewBox: "0 0 10 10"
}, [/*#__PURE__*/vue.createVNode("circle", {
  cx: "5",
  cy: "5",
  r: "4"
})], -1);

vue.popScopeId();

var render = /*#__PURE__*/_withId(function (_ctx, _cache, $props, $setup, $data, $options) {
  var _component_GlobalEvents = vue.resolveComponent("GlobalEvents");

  return vue.openBlock(), vue.createBlock(vue.Fragment, null, [_hoisted_1, vue.createVNode("div", {
    ref: "cursorEl",
    class: ["gooey-cursor", {
      mouseOut: _ctx.mouseOut,
      clicking: _ctx.clicking,
      hoverActive: _ctx.hoverActive
    }],
    style: // @ts-ignore
    {
      '--color': _ctx.color || '',
      '--size': _ctx.size ? "".concat(_ctx.size, "px") : ''
    }
  }, [(vue.openBlock(true), vue.createBlock(vue.Fragment, null, vue.renderList(_ctx.length, function (i) {
    return vue.openBlock(), vue.createBlock("div", {
      key: i
    }, [_hoisted_2]);
  }), 128))], 6), vue.createVNode(_component_GlobalEvents, {
    onMousemove: _ctx.handleMouseMove,
    onMouseout: _cache[1] || (_cache[1] = function ($event) {
      return _ctx.mouseOut = true;
    }),
    onMouseleave: _cache[2] || (_cache[2] = function ($event) {
      return _ctx.mouseOut = true;
    }),
    onMouseenter: _cache[3] || (_cache[3] = function ($event) {
      return _ctx.mouseOut = false;
    }),
    onMousedown: _cache[4] || (_cache[4] = function ($event) {
      return _ctx.clicking = true;
    }),
    onMouseup: _cache[5] || (_cache[5] = function ($event) {
      return _ctx.clicking = false;
    })
  }, null, 8, ["onMousemove"])], 64);
});function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}var css_248z = ".svg-effect[data-v-3798d71c] {\n  position: absolute;\n  width: 0;\n  height: 0;\n  display: none;\n  pointer-events: none;\n}\n.gooey-cursor[data-v-3798d71c] {\n  pointer-events: none !important;\n  position: fixed !important;\n  z-index: var(--z-index, 9999);\n  top: 0 !important;\n  left: 0 !important;\n  margin: 0 !important;\n  padding: 0 !important;\n  filter: url(\"#gooey-cursor-svg-effect\");\n  width: var(--size, 2rem);\n  height: var(--size, 2rem);\n  --largest-scale: 1;\n  transition: opacity 0.2s;\n}\n.gooey-cursor div[data-v-3798d71c] {\n  --scale: 1;\n  position: absolute;\n  display: flex;\n  box-sizing: border-box;\n  top: 0;\n  left: 0;\n  width: 100%;\n  height: 100%;\n  will-change: transform;\n}\n.gooey-cursor div svg[data-v-3798d71c] {\n  margin: auto;\n  width: 100%;\n  height: 100%;\n  transform: scale(var(--scale));\n}\n.gooey-cursor div svg circle[data-v-3798d71c] {\n  fill: var(--color, #42b883);\n}\n.gooey-cursor div:last-of-type svg[data-v-3798d71c] {\n  transform: scale(var(--largest-scale));\n  transition: transform 100ms cubic-bezier(0.51, 0.06, 0.56, 1.37);\n}\n.gooey-cursor.mouseOut[data-v-3798d71c] {\n  opacity: 0;\n}\n.gooey-cursor.hoverActive[data-v-3798d71c] {\n  opacity: 0.6;\n  --largest-scale: 1.4;\n}\n.gooey-cursor.hoverActive.clicking[data-v-3798d71c] {\n  --largest-scale: 1.1;\n}\n.gooey-cursor.clicking[data-v-3798d71c] {\n  --largest-scale: 1.3;\n}";
styleInject(css_248z);script.render = render;
script.__scopeId = "data-v-3798d71c";// Import vue component

// Default export is installable instance of component.
// IIFE injects install function into component, allowing component
// to be registered via Vue.use() as well as Vue.component(),
var component = /*#__PURE__*/(function () {
  // Assign InstallableComponent type
  var installable = script; // Attach install function executed by Vue.use()

  installable.install = function (app) {
    app.component('VueGooeyCursor', installable);
  };

  return installable;
})(); // It's possible to expose named exports when writing components that can
// also be used as directives, etc. - eg. import { RollupDemoDirective } from 'rollup-demo';
// export const RollupDemoDirective = directive;
var namedExports=/*#__PURE__*/Object.freeze({__proto__:null,'default': component});// only expose one global var, with named exports exposed as properties of
// that global var (eg. plugin.namedExport)

Object.entries(namedExports).forEach(function (_ref) {
  var _ref2 = _slicedToArray(_ref, 2),
      exportName = _ref2[0],
      exported = _ref2[1];

  if (exportName !== 'default') component[exportName] = exported;
});module.exports=component;